#![allow(dead_code)]
#![allow(non_snake_case)]
#![allow(non_camel_case_types)]
#![allow(non_upper_case_globals)]
#![allow(unused_parens)]
#![allow(unused_imports)]
#![allow(unused_variables)]
#![allow(unused_attributes)]
use crate::module_eae1ac5e::String_::string;
use crate::module_3bd9ae6a::Native_::Rc;
use crate::module_3bd9ae6a::Native_::MutCell;
use crate::module_3bd9ae6a::Native_::defaultOf;
use crate::module_3bd9ae6a::Native_::arrayCreate;
use crate::module_3bd9ae6a::Native_::arrayCopy;
use crate::module_3bd9ae6a::Native_::arrayWithCapacity;
use crate::module_3bd9ae6a::Native_::arrayEmpty;
use crate::module_3bd9ae6a::Native_::comparer as comparer_1;
use crate::module_3bd9ae6a::Native_::getZero;
use crate::module_3bd9ae6a::Native_::HashSet;
use crate::module_3bd9ae6a::Native_::hashSetEmpty;
use crate::module_3bd9ae6a::Native_::hashSetFrom;
use crate::module_3bd9ae6a::Native_::HashMap;
use crate::module_3bd9ae6a::Native_::hashMapEmpty;
use crate::module_3bd9ae6a::Native_::tryGetValue;
use crate::module_3bd9ae6a::Native_::hashMapSet;
use crate::module_3bd9ae6a::Native_::hashMapGet;
use crate::module_3bd9ae6a::Native_::arrayFrom;
use crate::module_3bd9ae6a::Native_::hashMapAdd;
use crate::module_f222008f::Util_::compare;
use crate::module_971078fd::Interfaces_::IEnumerable_1;
use crate::module_52af85ec::Seq_::toArray;
pub mod Array_ {
    use super::*;
    pub mod SR {
        use super::*;
        pub fn indexOutOfBounds() -> Rc<str> {
            thread_local! {
                static indexOutOfBounds: Rc<str> =
    string("The index was outside the range of elements in the array.");
            };
            indexOutOfBounds.with(|value| value.clone())
        }
        pub fn inputArrayWasEmpty() -> Rc<str> {
            thread_local! {
                static inputArrayWasEmpty: Rc<str> = string("The input array was empty");
            };
            inputArrayWasEmpty.with(|value| value.clone())
        }
        pub fn inputArrayWasTooLong() -> Rc<str> {
            thread_local! {
                static inputArrayWasTooLong: Rc<str> = string("The input array was too long");
            };
            inputArrayWasTooLong.with(|value| value.clone())
        }
        pub fn inputArrayWasTooShort() -> Rc<str> {
            thread_local! {
                static inputArrayWasTooShort: Rc<str> =
    string("The input array has not enough elements");
            };
            inputArrayWasTooShort.with(|value| value.clone())
        }
        pub fn inputMustBeNonNegative() -> Rc<str> {
            thread_local! {
                static inputMustBeNonNegative: Rc<str> =
    string("The input must be non-negative");
            };
            inputMustBeNonNegative.with(|value| value.clone())
        }
        pub fn inputMustBePositive() -> Rc<str> {
            thread_local! {
                static inputMustBePositive: Rc<str> = string("The input must be positive");
            };
            inputMustBePositive.with(|value| value.clone())
        }
        pub fn keyNotFoundAlt() -> Rc<str> {
            thread_local! {
                static keyNotFoundAlt: Rc<str> =
    string("An index satisfying the predicate was not found in the collection.");
            };
            keyNotFoundAlt.with(|value| value.clone())
        }
        pub fn differentLengths() -> Rc<str> {
            thread_local! {
                static differentLengths: Rc<str> = string("Arrays had different lengths");
            };
            differentLengths.with(|value| value.clone())
        }
        pub fn invalidPermutation() -> Rc<str> {
            thread_local! {
                static invalidPermutation: Rc<str> = string("Not a valid permutation");
            };
            invalidPermutation.with(|value| value.clone())
        }
    }
    pub fn indexNotFound<_a: Clone + 'static>() -> _a {
        panic!("{}", Array_::SR::keyNotFoundAlt())
    }
    pub fn differentLengths<_a: Clone + 'static>() -> _a {
        panic!("{}", Array_::SR::differentLengths())
    }
    pub fn empty<T: Clone + 'static>() -> Rc<MutCell<Vec<T>>> {
        arrayCreate(&0i32, &defaultOf::<T>())
    }
    pub fn create<T: Clone + 'static>(count: i32, value: T)
     -> Rc<MutCell<Vec<T>>> {
        arrayCreate(&count, &value)
    }
    pub fn zeroCreate<T: Clone + 'static>(count: i32) -> Rc<MutCell<Vec<T>>> {
        arrayCreate(&count, &defaultOf::<T>())
    }
    pub fn singleton<T: Clone + 'static>(value: T) -> Rc<MutCell<Vec<T>>> {
        arrayCreate(&1i32, &value)
    }
    pub fn isEmpty<T: Clone + 'static>(source: Rc<MutCell<Vec<T>>>) -> bool {
        source.is_empty()
    }
    pub fn length<T: Clone + 'static>(source: Rc<MutCell<Vec<T>>>) -> i32 {
        source.len() as i32
    }
    pub fn item<T: Clone + 'static>(index: i32, source: Rc<MutCell<Vec<T>>>)
     -> T {
        source[index].clone()
    }
    pub fn get<T: Clone + 'static>(source: Rc<MutCell<Vec<T>>>, index: i32)
     -> T {
        source[index].clone()
    }
    pub fn set<T: Clone +
               'static>(source: Rc<MutCell<Vec<T>>>, index: i32, value: T) {
        source.get_mut()[index as usize] = value;
    }
    pub fn copy<T: Clone + 'static>(source: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<T>>> {
        arrayCopy(source)
    }
    pub fn tryItem<T: Clone +
                   'static>(index: i32, source: Rc<MutCell<Vec<T>>>)
     -> Option<T> {
        if if index < 0i32 { true } else { index >= source.len() as i32 } {
            None::<T>
        } else { Some(source[index].clone()) }
    }
    pub fn reverse<T: Clone + 'static>(source: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<T>>> {
        let res: Rc<MutCell<Vec<T>>> = arrayCopy(source);
        res.clone().get_mut().reverse();
        res.clone()
    }
    pub fn fill<T: Clone +
                'static>(target: Rc<MutCell<Vec<T>>>, targetIndex: i32,
                         count: i32, value: T) {
        if if targetIndex < 0i32 {
               true
           } else { targetIndex + count > target.len() as i32 } {
            panic!("{}",
                   Rc::from((Rc::from(Array_::SR::indexOutOfBounds().to_string() +
                       &string("\\nParameter name: ")) as Rc<str>).to_string()
             + &string("index")) as Rc<str>);
        }
        {
            let len: i32 = target.len() as i32;
            for i in targetIndex..=targetIndex + count - 1i32 {
                target.get_mut()[i as usize] = value.clone();
            }
        }
    }
    pub fn getSubArray<T: Clone +
                       'static>(source: Rc<MutCell<Vec<T>>>, startIndex: i32,
                                count: i32) -> Rc<MutCell<Vec<T>>> {
        if if startIndex < 0i32 {
               true
           } else { startIndex + count > source.len() as i32 } {
            panic!("{}",
                   Rc::from((Rc::from(Array_::SR::indexOutOfBounds().to_string() +
                       &string("\\nParameter name: ")) as Rc<str>).to_string()
             + &string("index")) as Rc<str>);
        }
        {
            let res: Rc<MutCell<Vec<T>>> = arrayWithCapacity::<T>(count);
            for i in 0i32..=count - 1i32 {
                res.get_mut().push(source[startIndex + i].clone());
            }
            res.clone()
        }
    }
    pub fn exactlyOne<T: Clone + 'static>(source: Rc<MutCell<Vec<T>>>) -> T {
        if source.len() as i32 == 1i32 {
            source[0i32].clone()
        } else {
            if source.is_empty() {
                panic!("{}",
                       Rc::from((Rc::from(Array_::SR::inputArrayWasEmpty().to_string() +
                       &string("\\nParameter name: ")) as Rc<str>).to_string()
             + &string("source")) as Rc<str>)
            } else {
                panic!("{}",
                       Rc::from((Rc::from(Array_::SR::inputArrayWasTooLong().to_string() +
                       &string("\\nParameter name: ")) as Rc<str>).to_string()
             + &string("source")) as Rc<str>)
            }
        }
    }
    pub fn tryExactlyOne<T: Clone + 'static>(source: Rc<MutCell<Vec<T>>>)
     -> Option<T> {
        if source.len() as i32 == 1i32 {
            Some(source[0i32].clone())
        } else { None::<T> }
    }
    pub fn head<T: Clone + 'static>(source: Rc<MutCell<Vec<T>>>) -> T {
        if source.is_empty() {
            panic!("{}",
                   Rc::from((Rc::from(Array_::SR::inputArrayWasEmpty().to_string() +
                       &string("\\nParameter name: ")) as Rc<str>).to_string()
             + &string("source")) as Rc<str>)
        } else { source[0i32].clone() }
    }
    pub fn tryHead<T: Clone + 'static>(source: Rc<MutCell<Vec<T>>>)
     -> Option<T> {
        if source.is_empty() { None::<T> } else { Some(source[0i32].clone()) }
    }
    pub fn last<T: Clone + 'static>(source: Rc<MutCell<Vec<T>>>) -> T {
        if source.is_empty() {
            panic!("{}",
                   Rc::from((Rc::from(Array_::SR::inputArrayWasEmpty().to_string() +
                       &string("\\nParameter name: ")) as Rc<str>).to_string()
             + &string("source")) as Rc<str>)
        } else { source[source.len() as i32 - 1i32].clone() }
    }
    pub fn tryLast<T: Clone + 'static>(source: Rc<MutCell<Vec<T>>>)
     -> Option<T> {
        if source.is_empty() {
            None::<T>
        } else { Some(source[source.len() as i32 - 1i32].clone()) }
    }
    pub fn tail<T: Clone + 'static>(source: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<T>>> {
        if source.is_empty() {
            panic!("{}",
                   Rc::from((Rc::from(Array_::SR::inputArrayWasTooShort().to_string() +
                       &string("\\nParameter name: ")) as Rc<str>).to_string()
             + &string("source")) as Rc<str>);
        }
        Array_::getSubArray(source.clone(), 1i32, source.len() as i32 - 1i32)
    }
    pub fn append<T: Clone +
                  'static>(source1: Rc<MutCell<Vec<T>>>,
                           source2: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<T>>> {
        let len1: i32 = source1.len() as i32;
        let len2: i32 = source2.len() as i32;
        let res: Rc<MutCell<Vec<T>>> = arrayWithCapacity::<T>(len1 + len2);
        for i in 0i32..=len1 - 1i32 {
            res.get_mut().push(source1[i].clone());
        }
        for i_1 in 0i32..=len2 - 1i32 {
            res.get_mut().push(source2[i_1].clone());
        }
        res.clone()
    }
    pub fn choose<T: Clone + 'static, U: Clone +
                  'static>(chooser: Rc<impl Fn(T) -> (Option<U>) + 'static>,
                           source: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<U>>> {
        let res: Rc<MutCell<Vec<U>>> = arrayEmpty::<U>();
        for i in 0i32..=source.len() as i32 - 1i32 {
            let matchValue: Option<U> = chooser(source[i].clone());
            match &matchValue {
                None => (),
                Some(matchValue_0_0) => {
                    let x: U = matchValue_0_0.clone();
                    res.get_mut().push(x.clone())
                }
            }
        }
        res.clone()
    }
    pub fn compareWith<T: Clone +
                       'static>(comparer:
                                    Rc<impl Fn(T, T) -> (i32) + 'static>,
                                source1: Rc<MutCell<Vec<T>>>,
                                source2: Rc<MutCell<Vec<T>>>) -> i32 {
        let length1: i32 = source1.len() as i32;
        let length2: i32 = source2.len() as i32;
        let i: Rc<MutCell<i32>> = Rc::from(MutCell::from(0i32));
        let result: Rc<MutCell<i32>> = Rc::from(MutCell::from(0i32));
        if length1 < length2 {
            while if i.get() < source1.len() as i32 {
                      result.get() == 0i32
                  } else { false } {
                result.set(comparer(source1[i.get()].clone(),
                                    source2[i.get()].clone()));
                i.set(i.get() + 1i32)
            }
        } else {
            while if i.get() < source2.len() as i32 {
                      result.get() == 0i32
                  } else { false } {
                result.set(comparer(source1[i.get()].clone(),
                                    source2[i.get()].clone()));
                i.set(i.get() + 1i32)
            }
        }
        if result.get() != 0i32 {
            result.get()
        } else {
            if length1 == length2 {
                0i32
            } else { if length1 < length2 { -1i32 } else { 1i32 } }
        }
    }
    pub fn compareTo<T: PartialOrd + Clone +
                     'static>(source1: Rc<MutCell<Vec<T>>>,
                              source2: Rc<MutCell<Vec<T>>>) -> i32 {
        compare(source1, source2)
    }
    pub fn equalsTo<T: Eq + core::hash::Hash + Clone +
                    'static>(source1: Rc<MutCell<Vec<T>>>,
                             source2: Rc<MutCell<Vec<T>>>) -> bool {
        source1 == source2
    }
    pub fn mapIndexed<T: Clone + 'static, U: Clone +
                      'static>(mapping: Rc<impl Fn(i32, T) -> (U) + 'static>,
                               source: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<U>>> {
        let len: i32 = source.len() as i32;
        let res: Rc<MutCell<Vec<U>>> = arrayWithCapacity::<U>(len);
        for i in 0i32..=len - 1i32 {
            res.get_mut().push(mapping(i, source[i].clone()));
        }
        res.clone()
    }
    pub fn map<T: Clone + 'static, U: Clone +
               'static>(mapping: Rc<impl Fn(T) -> (U) + 'static>,
                        source: Rc<MutCell<Vec<T>>>) -> Rc<MutCell<Vec<U>>> {
        let len: i32 = source.len() as i32;
        let res: Rc<MutCell<Vec<U>>> = arrayWithCapacity::<U>(len);
        for i in 0i32..=len - 1i32 {
            res.get_mut().push(mapping(source[i].clone()));
        }
        res.clone()
    }
    pub fn mapIndexed2<T1: Clone + 'static, T2: Clone + 'static, U: Clone +
                       'static>(mapping:
                                    Rc<impl Fn(i32, T1, T2) -> (U) + 'static>,
                                source1: Rc<MutCell<Vec<T1>>>,
                                source2: Rc<MutCell<Vec<T2>>>)
     -> Rc<MutCell<Vec<U>>> {
        if source1.len() as i32 != source2.len() as i32 {
            panic!("{}", Array_::SR::differentLengths());
        }
        {
            let len: i32 = source1.len() as i32;
            let res: Rc<MutCell<Vec<U>>> = arrayWithCapacity::<U>(len);
            for i in 0i32..=len - 1i32 {
                res.get_mut().push(mapping(i, source1[i].clone(),
                                           source2[i].clone()));
            }
            res.clone()
        }
    }
    pub fn map2<T1: Clone + 'static, T2: Clone + 'static, U: Clone +
                'static>(mapping: Rc<impl Fn(T1, T2) -> (U) + 'static>,
                         source1: Rc<MutCell<Vec<T1>>>,
                         source2: Rc<MutCell<Vec<T2>>>)
     -> Rc<MutCell<Vec<U>>> {
        if source1.len() as i32 != source2.len() as i32 {
            panic!("{}", Array_::SR::differentLengths());
        }
        {
            let len: i32 = source1.len() as i32;
            let res: Rc<MutCell<Vec<U>>> = arrayWithCapacity::<U>(len);
            for i in 0i32..=len - 1i32 {
                res.get_mut().push(mapping(source1[i].clone(),
                                           source2[i].clone()));
            }
            res.clone()
        }
    }
    pub fn map3<T1: Clone + 'static, T2: Clone + 'static, T3: Clone + 'static,
                U: Clone +
                'static>(mapping: Rc<impl Fn(T1, T2, T3) -> (U) + 'static>,
                         source1: Rc<MutCell<Vec<T1>>>,
                         source2: Rc<MutCell<Vec<T2>>>,
                         source3: Rc<MutCell<Vec<T3>>>)
     -> Rc<MutCell<Vec<U>>> {
        if if source1.len() as i32 != source2.len() as i32 {
               true
           } else { source2.len() as i32 != source3.len() as i32 } {
            panic!("{}", Array_::SR::differentLengths());
        }
        {
            let len: i32 = source1.len() as i32;
            let res: Rc<MutCell<Vec<U>>> = arrayWithCapacity::<U>(len);
            for i in 0i32..=len - 1i32 {
                res.get_mut().push(mapping(source1[i].clone(),
                                           source2[i].clone(),
                                           source3[i].clone()));
            }
            res.clone()
        }
    }
    pub fn mapFold<State: Clone + 'static, T: Clone + 'static, U: Clone +
                   'static>(mapping:
                                Rc<impl Fn(State, T) -> ((U, State)) +
                                   'static>, state: State,
                            source: Rc<MutCell<Vec<T>>>)
     -> (Rc<MutCell<Vec<U>>>, State) {
        let acc: Rc<MutCell<State>> = Rc::from(MutCell::from(state));
        let len: i32 = source.len() as i32;
        let res: Rc<MutCell<Vec<U>>> = arrayWithCapacity::<U>(len);
        for i in 0i32..=len - 1i32 {
            let m: (U, State) = mapping(acc.get().clone(), source[i].clone());
            res.get_mut().push(m.0.clone());
            acc.set(m.1.clone())
        }
        (res.clone(), acc.get().clone())
    }
    pub fn mapFoldBack<T: Clone + 'static, State: Clone + 'static, U: Clone +
                       'static>(mapping:
                                    Rc<impl Fn(T, State) -> ((U, State)) +
                                       'static>, source: Rc<MutCell<Vec<T>>>,
                                state: State)
     -> (Rc<MutCell<Vec<U>>>, State) {
        let acc: Rc<MutCell<State>> = Rc::from(MutCell::from(state));
        let len: i32 = source.len() as i32;
        let res: Rc<MutCell<Vec<U>>> = arrayWithCapacity::<U>(len);
        for i in (0i32..=len - 1i32).rev() {
            let m: (U, State) = mapping(source[i].clone(), acc.get().clone());
            res.get_mut().push(m.0.clone());
            acc.set(m.1.clone())
        }
        res.get_mut().reverse();
        (res.clone(), acc.get().clone())
    }
    pub fn indexed<T: Clone + 'static>(source: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<(i32, T)>>> {
        let len: i32 = source.len() as i32;
        let res: Rc<MutCell<Vec<(i32, T)>>> =
            arrayWithCapacity::<(i32, T)>(len);
        for i in 0i32..=len - 1i32 {
            res.get_mut().push((i, source[i].clone()));
        }
        res.clone()
    }
    pub fn concat<T: Clone +
                  'static>(sources: Rc<MutCell<Vec<Rc<MutCell<Vec<T>>>>>>)
     -> Rc<MutCell<Vec<T>>> {
        let len: Rc<MutCell<i32>> = Rc::from(MutCell::from(0i32));
        for idx in 0i32..=sources.len() as i32 - 1i32 {
            let arr: Rc<MutCell<Vec<T>>> = sources[idx].clone();
            len.set(len.get() + arr.len() as i32)
        }
        {
            let res: Rc<MutCell<Vec<T>>> = arrayWithCapacity::<T>(len.get());
            for idx_1 in 0i32..=sources.len() as i32 - 1i32 {
                let arr_1: Rc<MutCell<Vec<T>>> = sources[idx_1].clone();
                for idx_2 in 0i32..=arr_1.len() as i32 - 1i32 {
                    let x: T = arr_1[idx_2].clone();
                    res.get_mut().push(x.clone())
                }
            }
            res.clone()
        }
    }
    pub fn collect<T: Clone + 'static, U: Clone +
                   'static>(mapping:
                                Rc<impl Fn(T) -> (Rc<MutCell<Vec<U>>>) +
                                   'static>, source: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<U>>> {
        Array_::concat(Array_::map(mapping, source))
    }
    pub fn exists<T: Clone +
                  'static>(predicate: Rc<impl Fn(T) -> (bool) + 'static>,
                           source: Rc<MutCell<Vec<T>>>) -> bool {
        let i: Rc<MutCell<i32>> = Rc::from(MutCell::from(0i32));
        let res: Rc<MutCell<bool>> = Rc::from(MutCell::from(false));
        while if i.get() < source.len() as i32 { !res.get() } else { false } {
            res.set(predicate(source[i.get()].clone()));
            i.set(i.get() + 1i32)
        }
        res.get()
    }
    pub fn exists2<T1: Clone + 'static, T2: Clone +
                   'static>(predicate:
                                Rc<impl Fn(T1, T2) -> (bool) + 'static>,
                            source1: Rc<MutCell<Vec<T1>>>,
                            source2: Rc<MutCell<Vec<T2>>>) -> bool {
        if source1.len() as i32 != source2.len() as i32 {
            panic!("{}", Array_::SR::differentLengths());
        }
        {
            let i: Rc<MutCell<i32>> = Rc::from(MutCell::from(0i32));
            let res: Rc<MutCell<bool>> = Rc::from(MutCell::from(false));
            while if i.get() < source1.len() as i32 {
                      !res.get()
                  } else { false } {
                res.set(predicate(source1[i.get()].clone(),
                                  source2[i.get()].clone()));
                i.set(i.get() + 1i32)
            }
            res.get()
        }
    }
    pub fn contains<T: Eq + core::hash::Hash + Clone +
                    'static>(value: T, source: Rc<MutCell<Vec<T>>>) -> bool {
        Array_::exists(Rc::from({
                                    let value = value.clone();
                                    move |x: T| x.clone() == value.clone()
                                }), source)
    }
    pub fn filter<T: Clone +
                  'static>(predicate: Rc<impl Fn(T) -> (bool) + 'static>,
                           source: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<T>>> {
        let res: Rc<MutCell<Vec<T>>> = arrayEmpty::<T>();
        for i in 0i32..=source.len() as i32 - 1i32 {
            if predicate(source[i].clone()) {
                res.get_mut().push(source[i].clone());
            };
        }
        res.clone()
    }
    pub fn initialize<T: Clone +
                      'static>(count: i32,
                               initializer: Rc<impl Fn(i32) -> (T) + 'static>)
     -> Rc<MutCell<Vec<T>>> {
        if count < 0i32 {
            panic!("{}",
                   Rc::from((Rc::from(Array_::SR::inputMustBeNonNegative().to_string() +
                       &string("\\nParameter name: ")) as Rc<str>).to_string()
             + &string("count")) as Rc<str>);
        }
        {
            let res: Rc<MutCell<Vec<T>>> = arrayWithCapacity::<T>(count);
            for i in 0i32..=count - 1i32 {
                res.get_mut().push(initializer(i));
            }
            res.clone()
        }
    }
    pub fn pairwise<T: Clone + 'static>(source: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<(T, T)>>> {
        if (source.len() as i32) < 2i32 {
            arrayEmpty::<(T, T)>()
        } else {
            let len: i32 = source.len() as i32 - 1i32;
            let res: Rc<MutCell<Vec<(T, T)>>> =
                arrayWithCapacity::<(T, T)>(len);
            for i in 0i32..=len - 1i32 {
                res.get_mut().push((source[i].clone(),
                                    source[i + 1i32].clone()));
            }
            res.clone()
        }
    }
    pub fn partition<T: Clone +
                     'static>(predicate: Rc<impl Fn(T) -> (bool) + 'static>,
                              source: Rc<MutCell<Vec<T>>>)
     -> (Rc<MutCell<Vec<T>>>, Rc<MutCell<Vec<T>>>) {
        let res1: Rc<MutCell<Vec<T>>> = arrayEmpty::<T>();
        let res2: Rc<MutCell<Vec<T>>> = arrayEmpty::<T>();
        for i in 0i32..=source.len() as i32 - 1i32 {
            if predicate(source[i].clone()) {
                res1.get_mut().push(source[i].clone())
            } else { res2.get_mut().push(source[i].clone()) };
        }
        (res1.clone(), res2.clone())
    }
    pub fn reduce<T: Clone +
                  'static>(reduction: Rc<impl Fn(T, T) -> (T) + 'static>,
                           source: Rc<MutCell<Vec<T>>>) -> T {
        if source.is_empty() {
            panic!("{}", Array_::SR::inputArrayWasEmpty());
        }
        {
            let folder =
                Rc::from({
                             let reduction = reduction.clone();
                             move |i: i32, acc: T, x: T|
                                 if i == 0i32 {
                                     x.clone()
                                 } else { reduction(acc.clone(), x.clone()) }
                         });
            let acc_1: Rc<MutCell<T>> =
                Rc::from(MutCell::from(source[0i32].clone()));
            for i_1 in 0i32..=source.len() as i32 - 1i32 {
                acc_1.set(folder(i_1, acc_1.get().clone(),
                                 source[i_1].clone()));
            }
            acc_1.get().clone()
        }
    }
    pub fn reduceBack<T: Clone +
                      'static>(reduction: Rc<impl Fn(T, T) -> (T) + 'static>,
                               source: Rc<MutCell<Vec<T>>>) -> T {
        if source.is_empty() {
            panic!("{}", Array_::SR::inputArrayWasEmpty());
        }
        {
            let folder =
                Rc::from({
                             let reduction = reduction.clone();
                             move |i: i32, x: T, acc: T|
                                 if i == 0i32 {
                                     x.clone()
                                 } else { reduction(acc.clone(), x.clone()) }
                         });
            let len: i32 = source.len() as i32;
            let acc_1: Rc<MutCell<T>> =
                Rc::from(MutCell::from(source[len - 1i32].clone()));
            for i_1 in 1i32..=len {
                acc_1.set(folder(i_1 - 1i32, source[len - i_1].clone(),
                                 acc_1.get().clone()));
            }
            acc_1.get().clone()
        }
    }
    pub fn replicate<T: Clone + 'static>(count: i32, initial: T)
     -> Rc<MutCell<Vec<T>>> {
        Array_::initialize(count,
                           Rc::from({
                                        let initial = initial.clone();
                                        move |_arg1: i32| initial.clone()
                                    }))
    }
    pub fn scan<State: Clone + 'static, T: Clone +
                'static>(folder: Rc<impl Fn(State, T) -> (State) + 'static>,
                         state: State, source: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<State>>> {
        let len: i32 = source.len() as i32;
        let res: Rc<MutCell<Vec<State>>> = arrayCreate(&(len + 1i32), &state);
        res.get_mut()[0i32 as usize] = state.clone();
        for i in 0i32..=len - 1i32 {
            res.get_mut()[(i + 1i32) as usize] =
                folder(res[i].clone(), source[i].clone());
        }
        res.clone()
    }
    pub fn scanBack<T: Clone + 'static, State: Clone +
                    'static>(folder:
                                 Rc<impl Fn(T, State) -> (State) + 'static>,
                             source: Rc<MutCell<Vec<T>>>, state: State)
     -> Rc<MutCell<Vec<State>>> {
        let len: i32 = source.len() as i32;
        let res: Rc<MutCell<Vec<State>>> = arrayCreate(&(len + 1i32), &state);
        res.get_mut()[len as usize] = state.clone();
        for i in (0i32..=len - 1i32).rev() {
            res.get_mut()[i as usize] =
                folder(source[i].clone(), res[i + 1i32].clone());
        }
        res.clone()
    }
    pub fn skip<T: Clone + 'static>(count: i32, source: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<T>>> {
        if count > source.len() as i32 {
            panic!("{}",
                   Rc::from((Rc::from(Array_::SR::inputArrayWasTooShort().to_string() +
                       &string("\\nParameter name: ")) as Rc<str>).to_string()
             + &string("source")) as Rc<str>);
        }
        {
            let count_1: i32 = if count < 0i32 { 0i32 } else { count };
            Array_::getSubArray(source.clone(), count_1,
                                source.len() as i32 - count_1)
        }
    }
    pub fn skipWhile<T: Clone +
                     'static>(predicate: Rc<impl Fn(T) -> (bool) + 'static>,
                              source: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<T>>> {
        let count: Rc<MutCell<i32>> = Rc::from(MutCell::from(0i32));
        while if count.get() < source.len() as i32 {
                  predicate(source[count.get()].clone())
              } else { false } {
            count.set(count.get() + 1i32);
        }
        Array_::getSubArray(source.clone(), count.get(),
                            source.len() as i32 - count.get())
    }
    pub fn take<T: Clone + 'static>(count: i32, source: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<T>>> {
        if count < 0i32 {
            panic!("{}",
                   Rc::from((Rc::from(Array_::SR::inputMustBeNonNegative().to_string() +
                       &string("\\nParameter name: ")) as Rc<str>).to_string()
             + &string("count")) as Rc<str>);
        }
        if count > source.len() as i32 {
            panic!("{}",
                   Rc::from((Rc::from(Array_::SR::inputArrayWasTooShort().to_string() +
                       &string("\\nParameter name: ")) as Rc<str>).to_string()
             + &string("source")) as Rc<str>);
        }
        Array_::getSubArray(source.clone(), 0i32, count)
    }
    pub fn takeWhile<T: Clone +
                     'static>(predicate: Rc<impl Fn(T) -> (bool) + 'static>,
                              source: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<T>>> {
        let count: Rc<MutCell<i32>> = Rc::from(MutCell::from(0i32));
        while if count.get() < source.len() as i32 {
                  predicate(source[count.get()].clone())
              } else { false } {
            count.set(count.get() + 1i32);
        }
        Array_::getSubArray(source.clone(), 0i32, count.get())
    }
    pub fn truncate<T: Clone +
                    'static>(count: i32, source: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<T>>> {
        Array_::getSubArray(source.clone(), 0i32,
                            if count < 0i32 {
                                0i32
                            } else {
                                if count > source.len() as i32 {
                                    source.len() as i32
                                } else { count }
                            })
    }
    pub fn copyTo<T: Clone +
                  'static>(source: Rc<MutCell<Vec<T>>>, sourceIndex: i32,
                           target: Rc<MutCell<Vec<T>>>, targetIndex: i32,
                           count: i32) {
        let diff: i32 = targetIndex - sourceIndex;
        for i in sourceIndex..=sourceIndex + count - 1i32 {
            target.get_mut()[(i + diff) as usize] = source[i].clone();
        }
    }
    pub fn tryFind<T: Clone +
                   'static>(predicate: Rc<impl Fn(T) -> (bool) + 'static>,
                            source: Rc<MutCell<Vec<T>>>) -> Option<T> {
        fn inner_loop<T: Clone +
                      'static>(i: i32,
                               predicate_1:
                                   Rc<impl Fn(T) -> (bool) + 'static>,
                               source_1: Rc<MutCell<Vec<T>>>) -> Option<T> {
            let i: Rc<MutCell<i32>> = Rc::from(MutCell::from(i));
            let predicate_1 = Rc::from(MutCell::from(predicate_1.clone()));
            let source_1: Rc<MutCell<Rc<MutCell<Vec<T>>>>> =
                Rc::from(MutCell::from(source_1.clone()));
            '_inner_loop:
                loop  {
                    break '_inner_loop
                        (if i.get() >= source_1.get().len() as i32 {
                             None::<T>
                         } else {
                             if predicate_1(source_1[i.get()].clone()) {
                                 Some(source_1[i.get()].clone())
                             } else {
                                 let i_temp: i32 = i.get() + 1i32;
                                 let predicate_1_temp =
                                     predicate_1.get().clone();
                                 let source_1_temp: Rc<MutCell<Vec<T>>> =
                                     source_1.get().clone();
                                 i.set(i_temp);
                                 predicate_1.set(predicate_1_temp);
                                 source_1.set(source_1_temp);
                                 continue '_inner_loop
                             }
                         }) ;
                }
        }
        inner_loop(0i32, predicate, source)
    }
    pub fn find<T: Clone +
                'static>(predicate: Rc<impl Fn(T) -> (bool) + 'static>,
                         source: Rc<MutCell<Vec<T>>>) -> T {
        let matchValue: Option<T> = Array_::tryFind(predicate, source);
        match &matchValue {
            None => panic!("{}", Array_::SR::keyNotFoundAlt()),
            Some(matchValue_0_0) => matchValue_0_0.clone(),
        }
    }
    pub fn tryFindIndex<T: Clone +
                        'static>(predicate:
                                     Rc<impl Fn(T) -> (bool) + 'static>,
                                 source: Rc<MutCell<Vec<T>>>) -> Option<i32> {
        fn inner_loop<T: Clone +
                      'static>(i: i32,
                               predicate_1:
                                   Rc<impl Fn(T) -> (bool) + 'static>,
                               source_1: Rc<MutCell<Vec<T>>>) -> Option<i32> {
            let i: Rc<MutCell<i32>> = Rc::from(MutCell::from(i));
            let predicate_1 = Rc::from(MutCell::from(predicate_1.clone()));
            let source_1: Rc<MutCell<Rc<MutCell<Vec<T>>>>> =
                Rc::from(MutCell::from(source_1.clone()));
            '_inner_loop:
                loop  {
                    break '_inner_loop
                        (if i.get() >= source_1.get().len() as i32 {
                             None::<i32>
                         } else {
                             if predicate_1(source_1[i.get()].clone()) {
                                 Some(i.get())
                             } else {
                                 let i_temp: i32 = i.get() + 1i32;
                                 let predicate_1_temp =
                                     predicate_1.get().clone();
                                 let source_1_temp: Rc<MutCell<Vec<T>>> =
                                     source_1.get().clone();
                                 i.set(i_temp);
                                 predicate_1.set(predicate_1_temp);
                                 source_1.set(source_1_temp);
                                 continue '_inner_loop
                             }
                         }) ;
                }
        }
        inner_loop(0i32, predicate, source)
    }
    pub fn findIndex<T: Clone +
                     'static>(predicate: Rc<impl Fn(T) -> (bool) + 'static>,
                              source: Rc<MutCell<Vec<T>>>) -> i32 {
        let matchValue: Option<i32> = Array_::tryFindIndex(predicate, source);
        match &matchValue {
            None => panic!("{}", Array_::SR::keyNotFoundAlt()),
            Some(matchValue_0_0) => matchValue_0_0.clone(),
        }
    }
    pub fn indexOf<T: Eq + core::hash::Hash + Clone +
                   'static>(source: Rc<MutCell<Vec<T>>>, item: T) -> i32 {
        let matchValue: Option<i32> =
            Array_::tryFindIndex(Rc::from({
                                              let item = item.clone();
                                              move |x: T|
                                                  x.clone() == item.clone()
                                          }), source);
        match &matchValue {
            None => -1i32,
            Some(matchValue_0_0) => matchValue_0_0.clone(),
        }
    }
    pub fn tryFindBack<T: Clone +
                       'static>(predicate: Rc<impl Fn(T) -> (bool) + 'static>,
                                source: Rc<MutCell<Vec<T>>>) -> Option<T> {
        fn inner_loop<T: Clone +
                      'static>(i: i32,
                               predicate_1:
                                   Rc<impl Fn(T) -> (bool) + 'static>,
                               source_1: Rc<MutCell<Vec<T>>>) -> Option<T> {
            let i: Rc<MutCell<i32>> = Rc::from(MutCell::from(i));
            let predicate_1 = Rc::from(MutCell::from(predicate_1.clone()));
            let source_1: Rc<MutCell<Rc<MutCell<Vec<T>>>>> =
                Rc::from(MutCell::from(source_1.clone()));
            '_inner_loop:
                loop  {
                    break '_inner_loop
                        (if i.get() < 0i32 {
                             None::<T>
                         } else {
                             if predicate_1(source_1[i.get()].clone()) {
                                 Some(source_1[i.get()].clone())
                             } else {
                                 let i_temp: i32 = i.get() - 1i32;
                                 let predicate_1_temp =
                                     predicate_1.get().clone();
                                 let source_1_temp: Rc<MutCell<Vec<T>>> =
                                     source_1.get().clone();
                                 i.set(i_temp);
                                 predicate_1.set(predicate_1_temp);
                                 source_1.set(source_1_temp);
                                 continue '_inner_loop
                             }
                         }) ;
                }
        }
        inner_loop(source.len() as i32 - 1i32, predicate, source.clone())
    }
    pub fn findBack<T: Clone +
                    'static>(predicate: Rc<impl Fn(T) -> (bool) + 'static>,
                             source: Rc<MutCell<Vec<T>>>) -> T {
        let matchValue: Option<T> = Array_::tryFindBack(predicate, source);
        match &matchValue {
            None => panic!("{}", Array_::SR::keyNotFoundAlt()),
            Some(matchValue_0_0) => matchValue_0_0.clone(),
        }
    }
    pub fn tryFindIndexBack<T: Clone +
                            'static>(predicate:
                                         Rc<impl Fn(T) -> (bool) + 'static>,
                                     source: Rc<MutCell<Vec<T>>>)
     -> Option<i32> {
        fn inner_loop<T: Clone +
                      'static>(i: i32,
                               predicate_1:
                                   Rc<impl Fn(T) -> (bool) + 'static>,
                               source_1: Rc<MutCell<Vec<T>>>) -> Option<i32> {
            let i: Rc<MutCell<i32>> = Rc::from(MutCell::from(i));
            let predicate_1 = Rc::from(MutCell::from(predicate_1.clone()));
            let source_1: Rc<MutCell<Rc<MutCell<Vec<T>>>>> =
                Rc::from(MutCell::from(source_1.clone()));
            '_inner_loop:
                loop  {
                    break '_inner_loop
                        (if i.get() < 0i32 {
                             None::<i32>
                         } else {
                             if predicate_1(source_1[i.get()].clone()) {
                                 Some(i.get())
                             } else {
                                 let i_temp: i32 = i.get() - 1i32;
                                 let predicate_1_temp =
                                     predicate_1.get().clone();
                                 let source_1_temp: Rc<MutCell<Vec<T>>> =
                                     source_1.get().clone();
                                 i.set(i_temp);
                                 predicate_1.set(predicate_1_temp);
                                 source_1.set(source_1_temp);
                                 continue '_inner_loop
                             }
                         }) ;
                }
        }
        inner_loop(source.len() as i32 - 1i32, predicate, source.clone())
    }
    pub fn findIndexBack<T: Clone +
                         'static>(predicate:
                                      Rc<impl Fn(T) -> (bool) + 'static>,
                                  source: Rc<MutCell<Vec<T>>>) -> i32 {
        let matchValue: Option<i32> =
            Array_::tryFindIndexBack(predicate, source);
        match &matchValue {
            None => panic!("{}", Array_::SR::keyNotFoundAlt()),
            Some(matchValue_0_0) => matchValue_0_0.clone(),
        }
    }
    pub fn findLastIndex<T: Clone +
                         'static>(predicate:
                                      Rc<impl Fn(T) -> (bool) + 'static>,
                                  source: Rc<MutCell<Vec<T>>>) -> i32 {
        let matchValue: Option<i32> =
            Array_::tryFindIndexBack(predicate, source);
        match &matchValue {
            None => -1i32,
            Some(matchValue_0_0) => matchValue_0_0.clone(),
        }
    }
    pub fn tryPick<T: Clone + 'static, U: Clone +
                   'static>(chooser: Rc<impl Fn(T) -> (Option<U>) + 'static>,
                            source: Rc<MutCell<Vec<T>>>) -> Option<U> {
        fn inner_loop<T: Clone + 'static, U: Clone +
                      'static>(i: i32,
                               chooser_1:
                                   Rc<impl Fn(T) -> (Option<U>) + 'static>,
                               source_1: Rc<MutCell<Vec<T>>>) -> Option<U> {
            let i: Rc<MutCell<i32>> = Rc::from(MutCell::from(i));
            let chooser_1 = Rc::from(MutCell::from(chooser_1.clone()));
            let source_1: Rc<MutCell<Rc<MutCell<Vec<T>>>>> =
                Rc::from(MutCell::from(source_1.clone()));
            '_inner_loop:
                loop  {
                    break '_inner_loop
                        (if i.get() >= source_1.get().len() as i32 {
                             None::<U>
                         } else {
                             let matchValue: Option<U> =
                                 chooser_1(source_1[i.get()].clone());
                             if matchValue.is_none() {
                                 let i_temp: i32 = i.get() + 1i32;
                                 let chooser_1_temp = chooser_1.get().clone();
                                 let source_1_temp: Rc<MutCell<Vec<T>>> =
                                     source_1.get().clone();
                                 i.set(i_temp);
                                 chooser_1.set(chooser_1_temp);
                                 source_1.set(source_1_temp);
                                 continue '_inner_loop
                             } else { matchValue.clone() }
                         }) ;
                }
        }
        inner_loop(0i32, chooser, source)
    }
    pub fn pick<T: Clone + 'static, U: Clone +
                'static>(chooser: Rc<impl Fn(T) -> (Option<U>) + 'static>,
                         source: Rc<MutCell<Vec<T>>>) -> U {
        let matchValue: Option<U> = Array_::tryPick(chooser, source);
        match &matchValue {
            None => panic!("{}", Array_::SR::keyNotFoundAlt()),
            Some(matchValue_0_0) => matchValue_0_0.clone(),
        }
    }
    pub fn fold<State: Clone + 'static, T: Clone +
                'static>(folder: Rc<impl Fn(State, T) -> (State) + 'static>,
                         state: State, source: Rc<MutCell<Vec<T>>>) -> State {
        let acc: Rc<MutCell<State>> = Rc::from(MutCell::from(state));
        for i in 0i32..=source.len() as i32 - 1i32 {
            acc.set(folder(acc.get().clone(), source[i].clone()));
        }
        acc.get().clone()
    }
    pub fn foldBack<T: Clone + 'static, State: Clone +
                    'static>(folder:
                                 Rc<impl Fn(T, State) -> (State) + 'static>,
                             source: Rc<MutCell<Vec<T>>>, state: State)
     -> State {
        let acc: Rc<MutCell<State>> = Rc::from(MutCell::from(state));
        let len: i32 = source.len() as i32;
        for i in 1i32..=len {
            acc.set(folder(source[len - i].clone(), acc.get().clone()));
        }
        acc.get().clone()
    }
    pub fn fold2<State: Clone + 'static, T1: Clone + 'static, T2: Clone +
                 'static>(folder:
                              Rc<impl Fn(State, T1, T2) -> (State) + 'static>,
                          state: State, source1: Rc<MutCell<Vec<T1>>>,
                          source2: Rc<MutCell<Vec<T2>>>) -> State {
        let acc: Rc<MutCell<State>> = Rc::from(MutCell::from(state));
        if source1.len() as i32 != source2.len() as i32 {
            panic!("{}", Array_::SR::differentLengths());
        }
        for i in 0i32..=source1.len() as i32 - 1i32 {
            acc.set(folder(acc.get().clone(), source1[i].clone(),
                           source2[i].clone()));
        }
        acc.get().clone()
    }
    pub fn foldBack2<T1: Clone + 'static, T2: Clone + 'static, State: Clone +
                     'static>(folder:
                                  Rc<impl Fn(T1, T2, State) -> (State) +
                                     'static>, source1: Rc<MutCell<Vec<T1>>>,
                              source2: Rc<MutCell<Vec<T2>>>, state: State)
     -> State {
        let acc: Rc<MutCell<State>> = Rc::from(MutCell::from(state));
        if source1.len() as i32 != source2.len() as i32 {
            panic!("{}", Array_::SR::differentLengths());
        }
        {
            let len: i32 = source1.len() as i32;
            for i in 1i32..=len {
                acc.set(folder(source1[len - i].clone(),
                               source2[len - i].clone(), acc.get().clone()));
            }
            acc.get().clone()
        }
    }
    pub fn forAll<T: Clone +
                  'static>(predicate: Rc<impl Fn(T) -> (bool) + 'static>,
                           source: Rc<MutCell<Vec<T>>>) -> bool {
        let i: Rc<MutCell<i32>> = Rc::from(MutCell::from(0i32));
        let res: Rc<MutCell<bool>> = Rc::from(MutCell::from(true));
        while if i.get() < source.len() as i32 { res.get() } else { false } {
            res.set(predicate(source[i.get()].clone()));
            i.set(i.get() + 1i32)
        }
        res.get()
    }
    pub fn forAll2<T1: Clone + 'static, T2: Clone +
                   'static>(predicate:
                                Rc<impl Fn(T1, T2) -> (bool) + 'static>,
                            source1: Rc<MutCell<Vec<T1>>>,
                            source2: Rc<MutCell<Vec<T2>>>) -> bool {
        if source1.len() as i32 != source2.len() as i32 {
            panic!("{}", Array_::SR::differentLengths());
        }
        {
            let i: Rc<MutCell<i32>> = Rc::from(MutCell::from(0i32));
            let res: Rc<MutCell<bool>> = Rc::from(MutCell::from(true));
            while if i.get() < source1.len() as i32 {
                      res.get()
                  } else { false } {
                res.set(predicate(source1[i.get()].clone(),
                                  source2[i.get()].clone()));
                i.set(i.get() + 1i32)
            }
            res.get()
        }
    }
    pub fn iterate<T: Clone +
                   'static>(action: Rc<impl Fn(T) + 'static>,
                            source: Rc<MutCell<Vec<T>>>) {
        for i in 0i32..=source.len() as i32 - 1i32 {
            action(source[i].clone());
        };
    }
    pub fn iterateIndexed<T: Clone +
                          'static>(action: Rc<impl Fn(i32, T) + 'static>,
                                   source: Rc<MutCell<Vec<T>>>) {
        for i in 0i32..=source.len() as i32 - 1i32 {
            action(i, source[i].clone());
        };
    }
    pub fn iterate2<T: Clone +
                    'static>(action: Rc<impl Fn(T, T) + 'static>,
                             source1: Rc<MutCell<Vec<T>>>,
                             source2: Rc<MutCell<Vec<T>>>) {
        if source1.len() as i32 != source2.len() as i32 {
            panic!("{}", Array_::SR::differentLengths());
        }
        for i in 0i32..=source1.len() as i32 - 1i32 {
            action(source1[i].clone(), source2[i].clone());
        }
    }
    pub fn iterateIndexed2<T: Clone +
                           'static>(action: Rc<impl Fn(i32, T, T) + 'static>,
                                    source1: Rc<MutCell<Vec<T>>>,
                                    source2: Rc<MutCell<Vec<T>>>) {
        if source1.len() as i32 != source2.len() as i32 {
            panic!("{}", Array_::SR::differentLengths());
        }
        for i in 0i32..=source1.len() as i32 - 1i32 {
            action(i, source1[i].clone(), source2[i].clone());
        }
    }
    pub fn permute<T: Clone +
                   'static>(indexMap: Rc<impl Fn(i32) -> (i32) + 'static>,
                            source: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<T>>> {
        let len: i32 = source.len() as i32;
        let res: Rc<MutCell<Vec<T>>> = arrayCopy(source.clone());
        let checkFlags: Rc<MutCell<Vec<i32>>> = arrayCreate(&len, &0i32);
        Array_::iterateIndexed(Rc::from({
                                            let checkFlags =
                                                checkFlags.clone();
                                            let indexMap = indexMap.clone();
                                            let len = len.clone();
                                            let res = res.clone();
                                            move |i: i32, x: T|
                                                {
                                                    let j: i32 = indexMap(i);
                                                    if if j < 0i32 {
                                                           true
                                                       } else { j >= len } {
                                                        panic!("{}",
                                                               Array_::SR::invalidPermutation());
                                                    }
                                                    res.get_mut()[j as usize]
                                                        = x.clone();
                                                    checkFlags.get_mut()[j as
                                                                             usize]
                                                        = 1i32
                                                }
                                        }), source.clone());
        if !Array_::forAll(Rc::from(move |y: i32| 1i32 == y),
                           checkFlags.clone()) {
            panic!("{}", Array_::SR::invalidPermutation());
        }
        res.clone()
    }
    pub fn sortInPlaceWith<T: Clone +
                           'static>(comparer:
                                        Rc<impl Fn(T, T) -> (i32) + 'static>,
                                    source: Rc<MutCell<Vec<T>>>) {
        source.get_mut().sort_by(comparer_1(Rc::from({
                                                         let comparer =
                                                             comparer.clone();
                                                         move
                                                             |delegateArg0: T,
                                                              delegateArg1: T|
                                                             comparer(delegateArg0.clone(),
                                                                      delegateArg1.clone())
                                                     })));
    }
    pub fn sortInPlace<T: PartialOrd + Clone +
                       'static>(source: Rc<MutCell<Vec<T>>>) {
        Array_::sortInPlaceWith(Rc::from(move |e1: T, e2: T|
                                             compare(e1.clone(), e2.clone())),
                                source);
    }
    pub fn sortInPlaceBy<T: Clone + 'static, U: PartialOrd + Clone +
                         'static>(projection: Rc<impl Fn(T) -> (U) + 'static>,
                                  source: Rc<MutCell<Vec<T>>>) {
        Array_::sortInPlaceWith(Rc::from({
                                             let projection =
                                                 projection.clone();
                                             move |x: T, y: T|
                                                 compare(projection(x.clone()),
                                                         projection(y.clone()))
                                         }), source);
    }
    pub fn sort<T: PartialOrd + Clone + 'static>(source: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<T>>> {
        let res: Rc<MutCell<Vec<T>>> = arrayCopy(source);
        Array_::sortInPlace(res.clone());
        res.clone()
    }
    pub fn sortBy<T: Clone + 'static, U: PartialOrd + Clone +
                  'static>(projection: Rc<impl Fn(T) -> (U) + 'static>,
                           source: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<T>>> {
        let res: Rc<MutCell<Vec<T>>> = arrayCopy(source);
        Array_::sortInPlaceBy(projection, res.clone());
        res.clone()
    }
    pub fn sortWith<T: Clone +
                    'static>(comparer: Rc<impl Fn(T, T) -> (i32) + 'static>,
                             source: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<T>>> {
        let res: Rc<MutCell<Vec<T>>> = arrayCopy(source);
        Array_::sortInPlaceWith(comparer, res.clone());
        res.clone()
    }
    pub fn sortDescending<T: PartialOrd + Clone +
                          'static>(source: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<T>>> {
        Array_::sortWith(Rc::from(move |x: T, y: T|
                                      compare(x.clone(), y.clone()) * -1i32),
                         source)
    }
    pub fn sortByDescending<T: Clone + 'static, U: PartialOrd + Clone +
                            'static>(projection:
                                         Rc<impl Fn(T) -> (U) + 'static>,
                                     source: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<T>>> {
        Array_::sortWith(Rc::from({
                                      let projection = projection.clone();
                                      move |x: T, y: T|
                                          compare(projection(x.clone()),
                                                  projection(y.clone())) *
                                              -1i32
                                  }), source)
    }
    pub fn allPairs<T1: Clone + 'static, T2: Clone +
                    'static>(xs: Rc<MutCell<Vec<T1>>>,
                             ys: Rc<MutCell<Vec<T2>>>)
     -> Rc<MutCell<Vec<(T1, T2)>>> {
        let len1: i32 = xs.len() as i32;
        let len2: i32 = ys.len() as i32;
        let res: Rc<MutCell<Vec<(T1, T2)>>> =
            arrayWithCapacity::<(T1, T2)>(len1 * len2);
        for i in 0i32..=len1 - 1i32 {
            for j in 0i32..=len2 - 1i32 {
                res.get_mut().push((xs[i].clone(), ys[j].clone()));
            };
        }
        res.clone()
    }
    pub fn unfold<State: Clone + 'static, T: Clone +
                  'static>(generator:
                               Rc<impl Fn(State) -> (Option<(T, State)>) +
                                  'static>, state: State)
     -> Rc<MutCell<Vec<T>>> {
        fn inner_loop<_a: Clone + 'static, T: Clone +
                      'static>(generator_1:
                                   Rc<impl Fn(_a) -> (Option<(T, _a)>) +
                                      'static>, state_1: _a,
                               res: Rc<MutCell<Vec<T>>>) {
            let generator_1 = Rc::from(MutCell::from(generator_1.clone()));
            let state_1: Rc<MutCell<_a>> = Rc::from(MutCell::from(state_1));
            let res: Rc<MutCell<Rc<MutCell<Vec<T>>>>> =
                Rc::from(MutCell::from(res.clone()));
            '_inner_loop:
                loop  {
                    break '_inner_loop
                        ({
                             let matchValue: Option<(T, _a)> =
                                 generator_1(state_1.get().clone());
                             match &matchValue {
                                 Some(matchValue_0_0) => {
                                     let x: T = matchValue_0_0.0.clone();
                                     let s: _a = matchValue_0_0.1.clone();
                                     res.get().get_mut().push(x);
                                     {
                                         let generator_1_temp =
                                             generator_1.get().clone();
                                         let state_1_temp: _a = s;
                                         let res_temp: Rc<MutCell<Vec<T>>> =
                                             res.get().clone();
                                         generator_1.set(generator_1_temp);
                                         state_1.set(state_1_temp);
                                         res.set(res_temp);
                                         continue '_inner_loop
                                     }
                                 }
                                 _ => (),
                             }
                         }) ;
                }
        }
        let res_1: Rc<MutCell<Vec<T>>> = arrayEmpty::<T>();
        inner_loop(generator, state, res_1.clone());
        res_1.clone()
    }
    pub fn unzip<T1: Clone + 'static, T2: Clone +
                 'static>(source: Rc<MutCell<Vec<(T1, T2)>>>)
     -> (Rc<MutCell<Vec<T1>>>, Rc<MutCell<Vec<T2>>>) {
        let len: i32 = source.len() as i32;
        let res1: Rc<MutCell<Vec<T1>>> = arrayWithCapacity::<T1>(len);
        let res2: Rc<MutCell<Vec<T2>>> = arrayWithCapacity::<T2>(len);
        Array_::iterateIndexed(Rc::from({
                                            let res1 = res1.clone();
                                            let res2 = res2.clone();
                                            move |i: i32, tupledArg: (T1, T2)|
                                                {
                                                    res1.get_mut().push(tupledArg.0.clone());
                                                    res2.get_mut().push(tupledArg.1.clone())
                                                }
                                        }), source.clone());
        (res1.clone(), res2.clone())
    }
    pub fn unzip3<T1: Clone + 'static, T2: Clone + 'static, T3: Clone +
                  'static>(source: Rc<MutCell<Vec<(T1, T2, T3)>>>)
     -> (Rc<MutCell<Vec<T1>>>, Rc<MutCell<Vec<T2>>>, Rc<MutCell<Vec<T3>>>) {
        let len: i32 = source.len() as i32;
        let res1: Rc<MutCell<Vec<T1>>> = arrayWithCapacity::<T1>(len);
        let res2: Rc<MutCell<Vec<T2>>> = arrayWithCapacity::<T2>(len);
        let res3: Rc<MutCell<Vec<T3>>> = arrayWithCapacity::<T3>(len);
        Array_::iterateIndexed(Rc::from({
                                            let res1 = res1.clone();
                                            let res2 = res2.clone();
                                            let res3 = res3.clone();
                                            move
                                                |i: i32,
                                                 tupledArg: (T1, T2, T3)|
                                                {
                                                    res1.get_mut().push(tupledArg.0.clone());
                                                    res2.get_mut().push(tupledArg.1.clone());
                                                    res3.get_mut().push(tupledArg.2.clone())
                                                }
                                        }), source.clone());
        (res1.clone(), res2.clone(), res3.clone())
    }
    pub fn zip<T1: Clone + 'static, T2: Clone +
               'static>(source1: Rc<MutCell<Vec<T1>>>,
                        source2: Rc<MutCell<Vec<T2>>>)
     -> Rc<MutCell<Vec<(T1, T2)>>> {
        Array_::map2(Rc::from(move |x: T1, y: T2| (x.clone(), y.clone())),
                     source1, source2)
    }
    pub fn zip3<T1: Clone + 'static, T2: Clone + 'static, T3: Clone +
                'static>(source1: Rc<MutCell<Vec<T1>>>,
                         source2: Rc<MutCell<Vec<T2>>>,
                         source3: Rc<MutCell<Vec<T3>>>)
     -> Rc<MutCell<Vec<(T1, T2, T3)>>> {
        Array_::map3(Rc::from(move |x: T1, y: T2, z: T3|
                                  (x.clone(), y.clone(), z.clone())), source1,
                     source2, source3)
    }
    pub fn chunkBySize<T: Clone +
                       'static>(chunkSize: i32, source: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<Rc<MutCell<Vec<T>>>>>> {
        if chunkSize <= 0i32 {
            panic!("{}",
                   Rc::from((Rc::from(Array_::SR::inputMustBePositive().to_string() +
                       &string("\\nParameter name: ")) as Rc<str>).to_string()
             + &string("size")) as Rc<str>);
        }
        {
            let len: i32 = source.len() as i32;
            let chunkCount: i32 = (len - 1i32) / chunkSize + 1i32;
            let res: Rc<MutCell<Vec<Rc<MutCell<Vec<T>>>>>> =
                arrayWithCapacity::<Rc<MutCell<Vec<T>>>>(chunkCount);
            for i in 0i32..=chunkCount - 1i32 {
                let start: i32 = i * chunkSize;
                let slice: Rc<MutCell<Vec<T>>> =
                    Array_::getSubArray(source.clone(), start,
                                        chunkSize.min(len - start));
                res.get_mut().push(slice.clone())
            }
            res.clone()
        }
    }
    pub fn splitAt<T: Clone +
                   'static>(index: i32, source: Rc<MutCell<Vec<T>>>)
     -> (Rc<MutCell<Vec<T>>>, Rc<MutCell<Vec<T>>>) {
        if if index < 0i32 { true } else { index > source.len() as i32 } {
            panic!("{}",
                   Rc::from((Rc::from(Array_::SR::indexOutOfBounds().to_string() +
                       &string("\\nParameter name: ")) as Rc<str>).to_string()
             + &string("index")) as Rc<str>);
        }
        (Array_::getSubArray(source.clone(), 0i32, index),
         Array_::getSubArray(source.clone(), index,
                             source.len() as i32 - index))
    }
    pub fn sum<T: core::ops::Add<Output = T> + Default + Clone +
               'static>(source: Rc<MutCell<Vec<T>>>) -> T {
        let acc: Rc<MutCell<T>> = Rc::from(MutCell::from(getZero::<T>()));
        for i in 0i32..=source.len() as i32 - 1i32 {
            acc.set(acc.get().clone() + source[i].clone());
        }
        acc.get().clone()
    }
    pub fn sumBy<T: Clone + 'static, U: core::ops::Add<Output = U> + Default +
                 Clone +
                 'static>(projection: Rc<impl Fn(T) -> (U) + 'static>,
                          source: Rc<MutCell<Vec<T>>>) -> U {
        let acc: Rc<MutCell<U>> = Rc::from(MutCell::from(getZero::<U>()));
        for i in 0i32..=source.len() as i32 - 1i32 {
            acc.set(acc.get().clone() + projection(source[i].clone()));
        }
        acc.get().clone()
    }
    pub fn maxBy<T: Clone + 'static, U: PartialOrd + Clone +
                 'static>(projection: Rc<impl Fn(T) -> (U) + 'static>,
                          xs: Rc<MutCell<Vec<T>>>) -> T {
        Array_::reduce(Rc::from({
                                    let projection = projection.clone();
                                    move |x: T, y: T|
                                        if projection(x.clone()) >
                                               projection(y.clone()) {
                                            x.clone()
                                        } else { y.clone() }
                                }), xs)
    }
    pub fn max<T: PartialOrd + Clone + 'static>(xs: Rc<MutCell<Vec<T>>>)
     -> T {
        Array_::reduce(Rc::from(move |x: T, y: T|
                                    if x.clone() > y.clone() {
                                        x.clone()
                                    } else { y.clone() }), xs)
    }
    pub fn minBy<T: Clone + 'static, U: PartialOrd + Clone +
                 'static>(projection: Rc<impl Fn(T) -> (U) + 'static>,
                          xs: Rc<MutCell<Vec<T>>>) -> T {
        Array_::reduce(Rc::from({
                                    let projection = projection.clone();
                                    move |x: T, y: T|
                                        if projection(x.clone()) <
                                               projection(y.clone()) {
                                            x.clone()
                                        } else { y.clone() }
                                }), xs)
    }
    pub fn min<T: PartialOrd + Clone + 'static>(xs: Rc<MutCell<Vec<T>>>)
     -> T {
        Array_::reduce(Rc::from(move |x: T, y: T|
                                    if x.clone() < y.clone() {
                                        x.clone()
                                    } else { y.clone() }), xs)
    }
    pub fn average<T: core::ops::Add<Output = T> +
                   core::ops::Div<Output = T> + From<i32> + Default + Clone +
                   'static>(source: Rc<MutCell<Vec<T>>>) -> T {
        if source.is_empty() {
            panic!("{}",
                   Rc::from((Rc::from(Array_::SR::inputArrayWasEmpty().to_string() +
                       &string("\\nParameter name: ")) as Rc<str>).to_string()
             + &string("source")) as Rc<str>);
        }
        {
            let total: Rc<MutCell<T>> =
                Rc::from(MutCell::from(getZero::<T>()));
            for i in 0i32..=source.len() as i32 - 1i32 {
                total.set(total.get().clone() + source[i].clone());
            }
            total.get().clone() / T::from(source.len() as i32)
        }
    }
    pub fn averageBy<T: Clone + 'static, U: core::ops::Add<Output = U> +
                     core::ops::Div<Output = U> + From<i32> + Default +
                     Clone +
                     'static>(projection: Rc<impl Fn(T) -> (U) + 'static>,
                              source: Rc<MutCell<Vec<T>>>) -> U {
        if source.is_empty() {
            panic!("{}",
                   Rc::from((Rc::from(Array_::SR::inputArrayWasEmpty().to_string() +
                       &string("\\nParameter name: ")) as Rc<str>).to_string()
             + &string("source")) as Rc<str>);
        }
        {
            let total: Rc<MutCell<U>> =
                Rc::from(MutCell::from(getZero::<U>()));
            for i in 0i32..=source.len() as i32 - 1i32 {
                total.set(total.get().clone() +
                              projection(source[i].clone()));
            }
            total.get().clone() / U::from(source.len() as i32)
        }
    }
    pub fn ofOption<T: Clone + 'static>(opt: Option<T>)
     -> Rc<MutCell<Vec<T>>> {
        match &opt {
            None => arrayCreate(&0i32, &defaultOf::<T>()),
            Some(opt_0_0) => arrayCreate(&1i32, &opt_0_0),
        }
    }
    pub fn r#where<T: Clone +
                   'static>(predicate: Rc<impl Fn(T) -> (bool) + 'static>,
                            source: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<T>>> {
        Array_::filter(predicate, source)
    }
    pub fn windowed<T: Clone +
                    'static>(windowSize: i32, source: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<Rc<MutCell<Vec<T>>>>>> {
        if windowSize <= 0i32 {
            panic!("{}",
                   Rc::from((Rc::from(Array_::SR::inputMustBePositive().to_string() +
                       &string("\\nParameter name: ")) as Rc<str>).to_string()
             + &string("size")) as Rc<str>);
        }
        {
            let len: i32 = 0i32.max(source.len() as i32 - windowSize + 1i32);
            let res: Rc<MutCell<Vec<Rc<MutCell<Vec<T>>>>>> =
                arrayWithCapacity::<Rc<MutCell<Vec<T>>>>(len);
            for i in 0i32..=len - 1i32 {
                let slice: Rc<MutCell<Vec<T>>> =
                    Array_::getSubArray(source.clone(), i, windowSize);
                res.get_mut().push(slice.clone())
            }
            res.clone()
        }
    }
    pub fn splitInto<T: Clone +
                     'static>(chunks: i32, source: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<Rc<MutCell<Vec<T>>>>>> {
        if chunks <= 0i32 {
            panic!("{}",
                   Rc::from((Rc::from(Array_::SR::inputMustBePositive().to_string() +
                       &string("\\nParameter name: ")) as Rc<str>).to_string()
             + &string("chunks")) as Rc<str>);
        }
        if source.is_empty() {
            arrayEmpty::<Rc<MutCell<Vec<T>>>>()
        } else {
            let res: Rc<MutCell<Vec<Rc<MutCell<Vec<T>>>>>> =
                arrayWithCapacity::<Rc<MutCell<Vec<T>>>>(chunks);
            let chunks_1: i32 = chunks.min(source.len() as i32);
            let minChunkSize: i32 = source.len() as i32 / chunks_1;
            let chunksWithExtraItem: i32 = source.len() as i32 % chunks_1;
            for i in 0i32..=chunks_1 - 1i32 {
                let chunkSize: i32 =
                    if i < chunksWithExtraItem {
                        minChunkSize + 1i32
                    } else { minChunkSize };
                let slice: Rc<MutCell<Vec<T>>> =
                    Array_::getSubArray(source.clone(),
                                        i * minChunkSize +
                                            chunksWithExtraItem.min(i),
                                        chunkSize);
                res.get_mut().push(slice.clone())
            }
            res.clone()
        }
    }
    pub fn transpose<T: Clone +
                     'static>(arrays: Rc<MutCell<Vec<Rc<MutCell<Vec<T>>>>>>)
     -> Rc<MutCell<Vec<Rc<MutCell<Vec<T>>>>>> {
        if arrays.is_empty() {
            arrayEmpty::<Rc<MutCell<Vec<T>>>>()
        } else {
            let len: i32 = arrays.len() as i32;
            let firstArray: Rc<MutCell<Vec<T>>> = arrays[0i32].clone();
            let innerLen: i32 = firstArray.len() as i32;
            if !Array_::forAll(Rc::from({
                                            let innerLen = innerLen.clone();
                                            move |a_2: Rc<MutCell<Vec<T>>>|
                                                a_2.len() as i32 == innerLen
                                        }), arrays.clone()) {
                panic!("{}", Array_::SR::differentLengths());
            }
            {
                let res: Rc<MutCell<Vec<Rc<MutCell<Vec<T>>>>>> =
                    arrayWithCapacity::<Rc<MutCell<Vec<T>>>>(innerLen);
                for i in 0i32..=innerLen - 1i32 {
                    let res2: Rc<MutCell<Vec<T>>> =
                        arrayWithCapacity::<T>(len);
                    for j in 0i32..=len - 1i32 {
                        res2.get_mut().push(arrays[j].clone()[i].clone());
                    }
                    res.get_mut().push(res2.clone())
                }
                res.clone()
            }
        }
    }
    pub fn distinct<T: Eq + core::hash::Hash + Clone +
                    'static>(xs: Rc<MutCell<Vec<T>>>) -> Rc<MutCell<Vec<T>>> {
        let hashSet: Rc<MutCell<HashSet<T>>> = hashSetEmpty::<T>();
        Array_::filter(Rc::from({
                                    let hashSet = hashSet.clone();
                                    move |x: T|
                                        hashSet.get_mut().insert(x.clone())
                                }), xs)
    }
    pub fn distinctBy<T: Clone + 'static, Key: Eq + core::hash::Hash + Clone +
                      'static>(projection: Rc<impl Fn(T) -> (Key) + 'static>,
                               xs: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<T>>> {
        let hashSet: Rc<MutCell<HashSet<Key>>> = hashSetEmpty::<Key>();
        Array_::filter(Rc::from({
                                    let hashSet = hashSet.clone();
                                    let projection = projection.clone();
                                    move |x: T|
                                        hashSet.get_mut().insert(projection(x.clone()))
                                }), xs)
    }
    pub fn except<T: Eq + core::hash::Hash + Clone +
                  'static>(itemsToExclude: Rc<dyn IEnumerable_1<T>>,
                           xs: Rc<MutCell<Vec<T>>>) -> Rc<MutCell<Vec<T>>> {
        let hashSet: Rc<MutCell<HashSet<T>>> =
            hashSetFrom(toArray(itemsToExclude));
        Array_::filter(Rc::from({
                                    let hashSet = hashSet.clone();
                                    move |x: T|
                                        hashSet.get_mut().insert(x.clone())
                                }), xs)
    }
    pub fn countBy<T: Clone + 'static, Key: Eq + core::hash::Hash + Clone +
                   'static>(projection: Rc<impl Fn(T) -> (Key) + 'static>,
                            xs: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<(Key, i32)>>> {
        let dict: Rc<MutCell<HashMap<Key, i32>>> = hashMapEmpty::<Key, i32>();
        let keys: Rc<MutCell<Vec<Key>>> = arrayEmpty::<Key>();
        for idx in 0i32..=xs.len() as i32 - 1i32 {
            let key: Key = projection(xs[idx].clone());
            let matchValue: (bool, i32) =
                {
                    let outArg: Rc<MutCell<i32>> =
                        Rc::from(MutCell::from(0i32));
                    (tryGetValue(dict.clone(), key.clone(), &outArg),
                     outArg.get())
                };
            if matchValue.0.clone() {
                hashMapSet(dict.clone(), key.clone(),
                           matchValue.1.clone() + 1i32)
            } else {
                hashMapSet(dict.clone(), key.clone(), 1i32);
                keys.get_mut().push(key.clone())
            }
        }
        Array_::map(Rc::from({
                                 let dict = dict.clone();
                                 move |key_1: Key|
                                     (key_1.clone(),
                                      hashMapGet(dict.clone(), key_1.clone()))
                             }), keys.clone())
    }
    pub fn groupBy<T: Clone + 'static, Key: Eq + core::hash::Hash + Clone +
                   'static>(projection: Rc<impl Fn(T) -> (Key) + 'static>,
                            xs: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<(Key, Rc<MutCell<Vec<T>>>)>>> {
        let dict: Rc<MutCell<HashMap<Key, Rc<MutCell<Vec<T>>>>>> =
            hashMapEmpty::<Key, Rc<MutCell<Vec<T>>>>();
        let keys: Rc<MutCell<Vec<Key>>> = arrayEmpty::<Key>();
        for idx in 0i32..=xs.len() as i32 - 1i32 {
            let x: T = xs[idx].clone();
            let key: Key = projection(x.clone());
            let matchValue: (bool, Rc<MutCell<Vec<T>>>) =
                {
                    let outArg: Rc<MutCell<Rc<MutCell<Vec<T>>>>> =
                        Rc::from(MutCell::from(arrayEmpty::<T>()));
                    (tryGetValue(dict.clone(), key.clone(), &outArg),
                     outArg.get().clone())
                };
            if matchValue.0.clone() {
                matchValue.1.clone().get_mut().push(x.clone())
            } else {
                hashMapAdd(dict.clone(), key.clone(), arrayFrom(&[x]));
                keys.get_mut().push(key.clone())
            }
        }
        Array_::map(Rc::from({
                                 let dict = dict.clone();
                                 move |key_1: Key|
                                     (key_1.clone(),
                                      hashMapGet(dict.clone(), key_1.clone()))
                             }), keys.clone())
    }
    pub fn insertAt<T: Clone +
                    'static>(index: i32, y: T, xs: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<T>>> {
        let len: i32 = xs.len() as i32;
        if if index < 0i32 { true } else { index > len } {
            panic!("{}",
                   Rc::from((Rc::from(Array_::SR::indexOutOfBounds().to_string() +
                       &string("\\nParameter name: ")) as Rc<str>).to_string()
             + &string("index")) as Rc<str>);
        }
        {
            let res: Rc<MutCell<Vec<T>>> = arrayWithCapacity::<T>(len + 1i32);
            for i in 0i32..=index - 1i32 {
                res.get_mut().push(xs[i].clone());
            }
            res.get_mut().push(y);
            for i_1 in index..=len - 1i32 {
                res.get_mut().push(xs[i_1].clone());
            }
            res.clone()
        }
    }
    pub fn insertManyAt<T: Clone +
                        'static>(index: i32, ys: Rc<dyn IEnumerable_1<T>>,
                                 xs: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<T>>> {
        let len: i32 = xs.len() as i32;
        if if index < 0i32 { true } else { index > len } {
            panic!("{}",
                   Rc::from((Rc::from(Array_::SR::indexOutOfBounds().to_string() +
                       &string("\\nParameter name: ")) as Rc<str>).to_string()
             + &string("index")) as Rc<str>);
        }
        {
            let ys_1: Rc<MutCell<Vec<T>>> = toArray(ys);
            let len2: i32 = ys_1.len() as i32;
            let res: Rc<MutCell<Vec<T>>> = arrayWithCapacity::<T>(len + len2);
            for i in 0i32..=index - 1i32 {
                res.get_mut().push(xs[i].clone());
            }
            for i_1 in 0i32..=len2 - 1i32 {
                res.get_mut().push(ys_1[i_1].clone());
            }
            for i_2 in index..=len - 1i32 {
                res.get_mut().push(xs[i_2].clone());
            }
            res.clone()
        }
    }
    pub fn removeAt<T: Clone + 'static>(index: i32, xs: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<T>>> {
        if if index < 0i32 { true } else { index >= xs.len() as i32 } {
            panic!("{}",
                   Rc::from((Rc::from(Array_::SR::indexOutOfBounds().to_string() +
                       &string("\\nParameter name: ")) as Rc<str>).to_string()
             + &string("index")) as Rc<str>);
        }
        {
            let i: Rc<MutCell<i32>> = Rc::from(MutCell::from(-1i32));
            Array_::filter(Rc::from({
                                        let i = i.clone();
                                        let index = index.clone();
                                        move |_arg1: T|
                                            {
                                                i.set(i.get() + 1i32);
                                                i.get() != index
                                            }
                                    }), xs.clone())
        }
    }
    pub fn removeManyAt<T: Clone +
                        'static>(index: i32, count: i32,
                                 xs: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<T>>> {
        let i: Rc<MutCell<i32>> = Rc::from(MutCell::from(-1i32));
        let status: Rc<MutCell<i32>> = Rc::from(MutCell::from(-1i32));
        let res: Rc<MutCell<Vec<T>>> =
            Array_::filter(Rc::from({
                                        let count = count.clone();
                                        let i = i.clone();
                                        let index = index.clone();
                                        let status = status.clone();
                                        move |_arg1: T|
                                            {
                                                i.set(i.get() + 1i32);
                                                if i.get() == index {
                                                    status.set(0i32);
                                                    false
                                                } else {
                                                    if i.get() > index {
                                                        if i.get() <
                                                               index + count {
                                                            false
                                                        } else {
                                                            status.set(1i32);
                                                            true
                                                        }
                                                    } else { true }
                                                }
                                            }
                                    }), xs);
        let status_1: i32 =
            if if status.get() == 0i32 {
                   i.get() + 1i32 == index + count
               } else { false } {
                1i32
            } else { status.get() };
        if status_1 < 1i32 {
            panic!("{}",
                   Rc::from((Rc::from(Array_::SR::indexOutOfBounds().to_string() +
                       &string("\\nParameter name: ")) as Rc<str>).to_string()
             +
             &(if status_1 < 0i32 {
                   string("index")
               } else { string("count") })) as Rc<str>);
        }
        res
    }
    pub fn updateAt<T: Clone +
                    'static>(index: i32, y: T, xs: Rc<MutCell<Vec<T>>>)
     -> Rc<MutCell<Vec<T>>> {
        let len: i32 = xs.len() as i32;
        if if index < 0i32 { true } else { index >= len } {
            panic!("{}",
                   Rc::from((Rc::from(Array_::SR::indexOutOfBounds().to_string() +
                       &string("\\nParameter name: ")) as Rc<str>).to_string()
             + &string("index")) as Rc<str>);
        }
        {
            let res: Rc<MutCell<Vec<T>>> = arrayWithCapacity::<T>(len);
            for i in 0i32..=len - 1i32 {
                res.get_mut().push(if i == index {
                                       y.clone()
                                   } else { xs[i].clone() });
            }
            res.clone()
        }
    }
}
